
#include "common.h"
//#include "MS.h"

void Allocate_memory(void)
{
	for (int ue_idx = 0; ue_idx < num_MS; ue_idx++)
	{
		ms[ue_idx].Allocate_memory();
	}


	for (int bs_idx = 0; bs_idx < num_BS; bs_idx++)
	{
		for (int ue_idx = 0; ue_idx < num_MS; ue_idx++)
		{
			channel[bs_idx][ue_idx].Allocate_memory();

		}
	}


	TX_LOS_gain_theta = new complex <double>[NUM_TX_Port];
	TX_LOS_gain_pi    = new complex <double>[NUM_TX_Port];

	TX_NLOS_gain_theta = new complex <double> **[NUM_TX_Port];
	TX_NLOS_gain_pi    = new complex <double> **[NUM_TX_Port];

	for (int p = 0; p < NUM_TX_Port; p++)
	{
		TX_NLOS_gain_theta[p] = new complex <double> *[MAX_NUM_CLUSTERS];
		TX_NLOS_gain_pi   [p] = new complex <double> *[MAX_NUM_CLUSTERS];
		 
		for (int i = 0; i < MAX_NUM_CLUSTERS; i++)
		{
			TX_NLOS_gain_theta[p][i] = new complex <double>[MAX_NUM_RAYS];
			TX_NLOS_gain_pi   [p][i] = new complex <double>[MAX_NUM_RAYS];
		}
	}

	RX_LOS_gain_theta = new complex <double>[NUM_RX_Port];
	RX_LOS_gain_pi    = new complex <double>[NUM_RX_Port];

	RX_NLOS_gain_theta = new complex <double> **[NUM_RX_Port];
	RX_NLOS_gain_pi    = new complex <double> **[NUM_RX_Port];

	for (int p = 0; p < NUM_RX_Port; p++)
	{
		RX_NLOS_gain_theta[p] = new complex <double> *[MAX_NUM_CLUSTERS];
		RX_NLOS_gain_pi[p]    = new complex <double> *[MAX_NUM_CLUSTERS];

		for (int i = 0; i < MAX_NUM_CLUSTERS; i++)
		{
			RX_NLOS_gain_theta[p][i] = new complex <double>[MAX_NUM_RAYS];
			RX_NLOS_gain_pi[p][i]    = new complex <double>[MAX_NUM_RAYS];
		}
	}


}